; [ HK256 ] 256-byte intro :: PC x86 / DOS
; (c) 2021 Jin X (t.me/jinxonik · jin_x@list.ru)
; Main code include file

; fasm 1.73.11+
; Requires Floating-Point Instruction Bytecode Generator & Recompiler (fpb.inc)

;-----------------------------------------------------------------------------------------------------------------------------------------------;
; I don't smoke and don't advise you too!!! Я не курю и вам не советую!!!                                                                       ;
;-----------------------------------------------------------------------------------------------------------------------------------------------;
; Author does not call anybody for any illegal actions, including the use and distribution of substances prohibited by law!                     ;
; Remember that smoking and use of alcohol and drugs is harmful to health and may violate the law of your country!                              ;
; Image generated but this program is only a demonstration of Floating-Point Instruction Bytecode Generator & Recompiler.                       ;
;-----------------------------------------------------------------------------------------------------------------------------------------------;
; Автор ни в коем случае не призывает к каким-либо противоправным действиям, в т.ч. употреблению и распространению запрещённых законом веществ! ;
; Помните, что курение и употребление алкоголя и наркотических веществ вредно для здоровья и может нарушать законодательство вашей страны!      ;
; Изображение, генерируемое программой, является лишь демонстрацией работы генератора и рекомпилятора байткода инструкций FPU.                  ;
;-----------------------------------------------------------------------------------------------------------------------------------------------;

;-- INTERNAL SETTINGS --------------------------------------------------------------------------------------------------

; FPB settings
define	fpb_copy_support 0			; disable native code copier support
define	fpb_var_support 1			; enable variable support
define	fpb_before_ret salc			; one-byte native instruction before 'ret' in recompiled function
;fpb_data_offset =	vars-consts		; offset of constants and variables (see comments in 'fpb.inc')

include '..\fpb.inc'				; include fpb generator & recompiler
fpb_check_version 1,0,0				; check fpb module version

; Declare fpb bytecode instructions
declare_fpb	+, faddp
declare_fpb	-, fsubp
declare_fpb	*, fmulp
declare_fpb	/, fdivp
declare_fpb	x2, fadd st0,st0
declare_fpb	^2, fmul st0,st0
declare_fpb	abs, fabs
declare_fpb	sqrt, fsqrt
declare_fpb	sin, fsin
declare_fpb	cos, fcos
declare_fpb	arctg, fpatan

;-- MAIN CODE ----------------------------------------------------------------------------------------------------------

org	$100

		; Assume: ax = bx = 0, cs = ds = es = ss
		; (not used: cx = $FF, dx = cs, si = $100, di = sp = $FFFE, bp = $9??, cf = 0)

		; Set video mode
		mov	al,$13
		int	$10

		; Recompile
		mov	di,$A000+20-10 - fpb_recompiled_code_size ; set this value to get di = $A000+20-10 after recompilation
		fpb_recompile! fpb_nibbles, fnaddr=bp, bh=0 ; insert recompiler code here (doesn't require 'call'), recompile from ds:fpb_nibbles to es:di (returns cx = 0, bx = 22, al = 1, cf = 1)

		; Set video segment
		mov	ds,di			; $A000+20-10

if color_theme = 0
		; Set palette
		mov	dx,$3C8
		out	dx,al
		inc	dx
	@@:	outsb				; red = 0
		out	dx,al			; green
		outsb				; blue = 0
		inc	al
		jns	@B
end if ; color_theme = 0

		; Animation
		mov	bp,consts-fpb_data_offset ; constant and variable arrays (with offset correction)
	.pixel:
		mov	di,@fpb_int_y
		mov	ax,$CCCD
		mul	bx			; dl = x (0..255), dh = y (0..199)
		mov	al,dh
		xor	al,128			; cf = 0
		cbw				; ax = y - 128
		stosw				; @fpb_int_x
		xchg	ax,dx
		cbw				; ax = x
		stosw				; @fpb_int_y
		call	$A000+20-10 - fpb_recompiled_code_size ; call recompiled function (al = 0 - 'salc' is executed before return, see 'fpb_before_ret' above)
		fistp	word [bp+di]		; round and store result
		mov	dx,[bp+di]		; get result
		dec	dx
		js	.black
		xchg	ax,dx
if color_theme = 0
		add	al,brightness
else if color_theme = 1
	@@:	add	al,$BD
else if color_theme = 2
	@@:	add	al,$75
else if color_theme = 3
	@@:	add	al,$2E
end if ; color_theme...
if sound
		out	$61,al
end if ; sound
	.black:
		mov	[bx],al			; put pixel
		inc	bx
		jnz	.pixel

if delay
		hlt
end if ; delay
		inc	word [es:di]		; next frame (@fpb_int_i++)
if allow_exit
		in	al,$60
		dec	al
		jnz	.pixel
		ret
else ; ~ allow_exit
		jmp	.pixel
end if ; allow_exit

		; Floating-point instruction bytecode
fpb_nibbles:
		; Author of original formula is Sukhinov Anton
		; a = arctg(cx - x, y - cy) + sin(i*in_sin_coef) / 3.5
		; r = sqrt((cx - x)^2 + (y - cy)^2) / cy  ; radius
		; cosa35 = cos(a*3.5)  ; original = cos(a*3.5 - 0.3*r^2)
		; app7 := (a+pi)*7  ; original = (a+pi)*7 - 0.3*r^2
		; arccos_cos = arccos(cos(app7))
		; sina2 = sin(a/2)
		;; f1 = 1 / (abs(cosa35) + 0.005/r)  ; outline
		;; f2 = ( sin(a*3.5)^2 / (r^2*10/sina2^2+1) ) / ( abs(sin((r-(arccos_cos+r*arccos_cos^2*2)/20)*pi*8)) + 0.125 + cosa35^2 ) * 8  ; original: 0.1 instead of 0.125  ; spikes
		;; f3 = 0  ; original = 3 / ((r*100)^2+0.1)  ; center
		;; f4 = abs(sina2) - r^2  ; very important coefficient :)
		;; f5 = abs(sina2) * (sin(i*in_sin_coef*3)+3) / 3.5  ; thickness of leaf (the smaller, the more lush)
		;; f6 = 1  ; original = 0.01 / ((sin(r*cos(a)*100+cos(r*sin(a)*40)*10) + sin(r*sin(a)*100+sin(r*cos(a)*40)*10))^2 + 0.01) + 1  ; don't know what is it, but it can be set to 1 without visible changes of image
		;; f7 = r * 0.0002 / (a^2 + 0.0002)  ; original = (r+0.2) * 0.0002 / ((a-r*0.1)^2 + 0.0001)  ; stalk
		;; f = ((f1 + f2 + f3) * f4 - f5) * f6 + f7
		; f(f3=0, f6=1) = ( (1 / (abs(cosa35) + 0.005/r) + ( sin(a*3.5)^2 / (r^2*10/sina2^2+1) ) / ( abs(sin((r-(arccos_cos+r*arccos_cos^2*2)/20)*pi*8)) + 0.125 + cosa35^2 ) * 8) * (abs(sina2) - r^2) - abs(sina2) * (sin(i*in_sin_coef*3)+3) / 3.5 ) + r * 0.0002 / (a^2 + 0.0002)
	fpb_start	consts
		; a = arctg(x, y) + sin(i*in_sin_coef) / 3.5; in_sin_coef = 0.125 :)
		fpb	x y arctg
		fpb	i 0.125 * sin 3.5 / +
		fpb	=a
		; r = sqrt(x^2 + y^2) / 100
		fpb	x ^2 y ^2 + sqrt 10 ^2 / =r
		; cosa35 = cos(a*3.5)
		fpb	a 3.5 * cos =cosa35
		; app7 := (a+pi)*7
		fpb	a pi + 3.5 x2 * =app7
		; arccos_cos = arccos(cos(app7)) = arctg(abs(sin(app7)), cos(app7)) | arccos(cos(x)) = arctg(abs(sin(x)), cos(x))
		fpb	app7 sin abs app7 cos arctg =arccos_cos
		; sina2 = sin(a/2)
		fpb	a 1 x2 / sin =sina2

		; f = (1 / (abs(cosa35) + 0.005/r) + ( sin(a*3.5)^2 / (r^2*10/sina2^2+1) ) / ( abs(sin((r-(arccos_cos+r*arccos_cos^2*2)/20)*pi*8)) + 0.125 + cosa35^2 ) * 8) * (abs(sina2) - r^2) - abs(sina2)...
		fpb	1 cosa35 abs 0.005 r / + / a 3.5 * sin ^2 r ^2 10 * sina2 ^2 / 1 + / r arccos_cos r arccos_cos ^2 * x2 + 10 x2 / - pi * 8 * sin abs 0.125 + cosa35 ^2 + / 8 * +
		fpb	sina2 abs r ^2 - * sina2 abs
		fpb	i 3.5 / sin pi + * 1 x2 / ; ... * (sin(i*in_sin_coef*3)+pi) / 2
		fpb	-			; this minus is for: abs(sina2) * (sin(i*in_sin_coef*3)+3) / 3.5
		; f += r * 0.0002 / (a^2 + 0.0002)
		fpb	r 0.0002 * a ^2 0.0002 + / +
		; f += 0.5
		fpb	0.125 x2 x2 +
	fpb_end

		; Constant and variable array (variables address is consts + fpb_data_offset)
	consts = $
		fpb_int	1
		fpb_flt 3.5			; placed here for more accuracy
		fpb_int	3
		fpb_int	8
		fpb_int	10
		fpb_flt 0.0002
		fpb_flt 0.005
		fpb_flt 0.125
		fpb_flt	pi, 3.14159265359
		fpb_int y, ?
		fpb_int x, ?
		fpb_int i, ?
	vars = $
		fpb_var	a
		fpb_var	r
		fpb_var	cosa35
		fpb_var	app7
		fpb_var	arccos_cos
		fpb_var	sina2

;-----------------------------------------------------------------------------------------------------------------------

; ┌─── ───────── ───────────────────────── ────────── -··
; │ ┌─── ───────── ───────────────────── ────────── ────┐
; │ │ ┌─── ───────── ───────────────── ▄▄▄▄▄▄▄▄▄─ ────┐ │
; │ │ │ ┌─── ───────── ───────────── ▄▀      ▄▀ ────┐ │ │
; │ │ │ │ ┌─── ▄▄▄▄▄▄▄▄▄ ────────  ▄▀      ▄▀ ────┐ │ │ │
; │ │ │ │ │     ▀▄      ▀▄       ▄▀      ▄▀     : │ │ │ │
; │ │ │ │ │       ▀       ▀▄   ▄▀      ▄▀       │ │ │ │ │
; │ │ │ │ │  ████████████▀  ▀▄▀ ▄██▀ ▄▀   ▄███  │ │ │ │ │
; │ │ │ │ │         ▄██▀      ▄██▀ ▄▀   ▄██▀██  │ │ │ │ │
; │ │ │ │ │       ▄██▀  ▀▄  ▄██▀ ▄▀   ▄██▀  ██  │ │ │ │ │
; │ │ │ │ │     ▄██▀   ▄▀ ▄██▀    ▀ ▄██▀    ██  │ │ │ │ │
; │ │ │ │ │   ▄██▀   ▄▀ ▄██▀ ▄    ▄██▀      ██  │ │ │ │ │
; │ │ │ │ │  ▀▀▀   ▄▀  ▀▀▀ ▄▀ ▀▄ ▀▀▀  ▀▄    ▀▀  │ │ │ │ │
; │ │ │ │ :      ▄▀      ▄▀     ▀▄      ▀▄      │ │ │ │ │
; │ │ │ └───── ▄▀      ▄▀ ─────── ▀▀▀▀▀▀▀▀▀ ────┘ │ │ │ │
; │ │ └───── ▄▀      ▄▀ ─────────── ───────── ────┘ │ │ │
; │ └───── ─▀▀▀▀▀▀▀▀▀ ─────────────── ───────── ────┘ │ │
; └───── ────────── ─────────────────── ───────── ────┘ │
; ··-— ────────── ─────────────────────── ───────── ────┘

; ====================[ Greetings to... ]====================
; HellMood^DESiRE  TomCat^Abaddon  superogue^Marquee Design
; Řrřola  Digimind  g0blinish  frag^fsqrt  Baudsurfer^RSi
; sensenstahl  Kuemmel  iONic^Astroidea  Georgy Lomsadze
; wbcbz7^sibCrew  DArt^Fenomen  Adam Bazaroff^Excess Team
; Dolphin Soft  bfox^insiders  TmK^deMarche  Manwe^SandS
; baze^3SC  ryg^Farbrausch  provod^jetlag … all sizecoders!
; ===========================================================

; .------------< Welcome to sizecoding chats!!! >-----------.
; | https://discord.gg/NeCSgBTZmh • https://t.me/sizecoders |
; '---------------------------------------------------------'
